'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

module.exports = function (_ref) {
  var template = _ref.template,
      types = _ref.types;

  var pluginOptions = void 0;
  var visitor = {
    CallExpression: {
      exit: function exit(path) {
        // Not `Object.defineProperty`, skip
        if (!path.get('callee.object').node) {
          return;
        }

        if (isExportsModuleDeclaration(path)) {
          var finder = new ExportFinder(path);

          if (finder.isOnlyDefaultExport()) {
            var root = finder.getRootNode();

            // HACK: `program.node.body.push` instead of pushContainer(due doesn't work in Plugin.post)
            root.node.body.push(template('module.exports = exports.default')());
            if (pluginOptions.addDefaultProperty) {
              root.node.body.push(template('module.exports.default = exports.default')());
            }
          }
        }
      }
    }
  };

  return {
    visitor: {
      Program: function Program(path, state) {
        // HACK: can't get plugin options in Plugin.post
        pluginOptions = state.opts;
      }
    },
    post: function post(fileMap) {
      fileMap.path.traverse(visitor);
    }
  };
};

function isExportsModuleDeclaration(path) {
  var callee = path.get('callee.object.name').node + '.' + path.get('callee.property.name').node;
  var args = path.get('arguments').map(function (path) {
    if (path.isStringLiteral()) {
      return path.get('value').node;
    }
    if (path.get('properties').length) {
      return path.get('properties.0.key.name').node + ':' + path.get('properties.0.value.value').node;
    }
  }).join(' ');

  // TODO: support loose syntax `  exports.__esModule = true;`
  return '' + callee + args === 'Object.defineProperty __esModule value:true';
}

var ExportFinder = function () {
  function ExportFinder(path) {
    _classCallCheck(this, ExportFinder);

    this.path = path;
    this.hasExportDefault = false;
    this.hasExportNamed = false;
  }

  _createClass(ExportFinder, [{
    key: 'getRootNode',
    value: function getRootNode() {
      return this.path.parentPath.parentPath;
    }
  }, {
    key: 'isOnlyDefaultExport',
    value: function isOnlyDefaultExport() {
      var _this = this;

      this.getRootNode().get('body').forEach(function (path) {
        if (path.isVariableDeclaration()) {
          _this.findExport(path.get('declarations.0'), 'init');
        } else {
          if (path.isExpressionStatement() && path.get('expression').isAssignmentExpression()) {
            _this.findExport(path);
          }
        }
      });
      return this.hasExportDefault && !this.hasExportNamed;
    }
  }, {
    key: 'findExport',
    value: function findExport(path) {
      var property = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'expression';

      // Not `exports.anything`, skip
      if (!path.get(property + '.left').node || !path.get(property + '.left.object').node) {
        return;
      }

      var objectName = path.get(property + '.left.object.name').node;
      var propertyName = path.get(property + '.left.property.name').node;
      if (objectName === 'exports') {
        if (propertyName === 'default') {
          this.hasExportDefault = true;
        } else {
          this.hasExportNamed = true;
        }
      }
      return null;
    }
  }]);

  return ExportFinder;
}();
//# sourceMappingURL=index.js.map